#version 430 core

layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv; 

out vec3 FragPos;
out vec3 Normal;
out vec2 TexCoords;

uniform mat4 projectionMatrix;
uniform mat4 modelMatrix;
uniform mat4 viewMatrix;

uniform bool reverseNormals;

void main()
{
	FragPos = vec3(modelMatrix * vec4(position, 1.0));
	
	TexCoords = uv;
	
	mat3 normalMatrix = transpose(inverse(mat3(modelMatrix)));
	mat4 MVP = projectionMatrix * viewMatrix * modelMatrix;

	if (reverseNormals)
		Normal = normalMatrix * (1.0 - normal);
	else
		Normal = normalMatrix * normal;
	gl_Position = MVP * vec4(position, 1.0);
}